var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { isDefined, mapObject } from "../utils";

export function getValueFromOverride(override, index, key, defaultValue) {
	if (isDefined(override) && override.index === index) return override[key];
	return defaultValue;
}

export function terminate() {
	this.setState({
		current: null,
		override: null
	});
}

export function saveNodeList(node) {
	if (isDefined(node)) {
		this.nodes[node.props.index] = node;
	}
}
export function saveNodeType(type) {
	var _this = this;

	return function (node) {
		_this.nodes[type] = node;
	};
}
export function handleClickInteractiveType(interactiveType) {
	return function (moreProps, e) {
		e.preventDefault();

		var onSelect = this.props.onSelect;

		if (isDefined(this.nodes)) {
			var selecedNodes = this.nodes.map(function (node) {
				return node.isHover(moreProps);
			});
			var interactive = this.state[interactiveType].map(function (t, idx) {
				return _extends({}, t, {
					selected: selecedNodes[idx]
				});
			});
			this.setState(_defineProperty({}, interactiveType, interactive));

			onSelect(interactive);
		}
	};
}

export function isHover(moreProps) {
	var hovering = mapObject(this.nodes, function (node) {
		return node.isHover(moreProps);
	}).reduce(function (a, b) {
		return a || b;
	});
	return hovering;
}