"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../utils");

var _utils2 = require("./utils");

var _EachFibRetracement = require("./hoc/EachFibRetracement");

var _EachFibRetracement2 = _interopRequireDefault(_EachFibRetracement);

var _MouseLocationIndicator = require("./components/MouseLocationIndicator");

var _MouseLocationIndicator2 = _interopRequireDefault(_MouseLocationIndicator);

var _HoverTextNearMouse = require("./components/HoverTextNearMouse");

var _HoverTextNearMouse2 = _interopRequireDefault(_HoverTextNearMouse);

var _GenericChartComponent = require("../GenericChartComponent");

var _GenericChartComponent2 = _interopRequireDefault(_GenericChartComponent);

var _GenericComponent = require("../GenericComponent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FibonacciRetracement = function (_Component) {
	_inherits(FibonacciRetracement, _Component);

	function FibonacciRetracement(props) {
		_classCallCheck(this, FibonacciRetracement);

		var _this = _possibleConstructorReturn(this, (FibonacciRetracement.__proto__ || Object.getPrototypeOf(FibonacciRetracement)).call(this, props));

		_this.handleStart = _this.handleStart.bind(_this);
		_this.handleEnd = _this.handleEnd.bind(_this);
		_this.handleDrawRetracement = _this.handleDrawRetracement.bind(_this);

		_this.handleEdge1Drag = _this.handleEdge1Drag.bind(_this);
		_this.handleEdge2Drag = _this.handleEdge2Drag.bind(_this);

		_this.handleDrag = _this.handleDrag.bind(_this);
		_this.handleDragComplete = _this.handleDragComplete.bind(_this);

		_this.terminate = _utils2.terminate.bind(_this);
		_this.handleClick = (0, _utils2.handleClickInteractiveType)("retracements").bind(_this);
		_this.saveNodeList = _utils2.saveNodeList.bind(_this);

		_this.nodes = [];
		_this.state = {
			retracements: []
		};
		return _this;
	}

	_createClass(FibonacciRetracement, [{
		key: "componentWillMount",
		value: function componentWillMount() {
			this.updateInteractiveToState(this.props.retracements);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(nextProps) {
			if (this.props.retracements !== nextProps.retracements) {
				this.updateInteractiveToState(nextProps.retracements);
			}
		}
	}, {
		key: "updateInteractiveToState",
		value: function updateInteractiveToState(retracements) {
			this.setState({
				retracements: retracements.map(function (t) {
					return _extends({}, t, {
						selected: !!t.selected
					});
				})
			});
		}
	}, {
		key: "handleStart",
		value: function handleStart(xyValue) {
			var _this2 = this;

			var current = this.state.current;

			if ((0, _utils.isNotDefined)(current) || (0, _utils.isNotDefined)(current.x1)) {
				this.mouseMoved = false;
				this.setState({
					current: {
						x1: xyValue[0],
						y1: xyValue[1],
						x2: null,
						y2: null
					}
				}, function () {
					_this2.props.onStart();
				});
			}
		}
	}, {
		key: "handleEnd",
		value: function handleEnd(xyValue, moreProps, e) {
			var _this3 = this;

			var _state = this.state,
			    retracements = _state.retracements,
			    current = _state.current;


			if (this.mouseMoved && (0, _utils.isDefined)(current) && (0, _utils.isDefined)(current.x1)) {
				var newRetracements = retracements.concat(_extends({}, current, {
					x2: xyValue[0],
					y2: xyValue[1],
					selected: true
				}));

				this.setState({
					current: null,
					retracements: newRetracements
				}, function () {
					_this3.props.onComplete(newRetracements, moreProps, e);
				});
			}
		}
	}, {
		key: "handleDrawRetracement",
		value: function handleDrawRetracement(xyValue) {
			var current = this.state.current;

			if ((0, _utils.isDefined)(current) && (0, _utils.isDefined)(current.x1)) {
				this.mouseMoved = true;
				this.setState({
					current: _extends({}, current, {
						x2: xyValue[0],
						y2: xyValue[1]
					})
				});
			}
		}
	}, {
		key: "handleDrag",
		value: function handleDrag(index, xy) {
			this.setState({
				override: _extends({
					index: index
				}, xy)
			});
		}
	}, {
		key: "handleEdge1Drag",
		value: function handleEdge1Drag(echo, newXYValue, origXYValue) {
			var retracements = this.state.retracements;
			var index = echo.index;


			var dx = origXYValue.x1Value - newXYValue.x1Value;

			this.setState({
				override: {
					index: index,
					x1: retracements[index].x1 - dx,
					y1: retracements[index].y1,
					x2: retracements[index].x2,
					y2: retracements[index].y2
				}
			});
		}
	}, {
		key: "handleEdge2Drag",
		value: function handleEdge2Drag(echo, newXYValue, origXYValue) {
			var retracements = this.state.retracements;
			var index = echo.index;


			var dx = origXYValue.x2Value - newXYValue.x2Value;

			this.setState({
				override: {
					index: index,
					x1: retracements[index].x1,
					y1: retracements[index].y1,
					x2: retracements[index].x2 - dx,
					y2: retracements[index].y2
				}
			});
		}
	}, {
		key: "handleDragComplete",
		value: function handleDragComplete(moreProps) {
			var _this4 = this;

			var _state2 = this.state,
			    retracements = _state2.retracements,
			    override = _state2.override;

			if ((0, _utils.isDefined)(override)) {
				var index = override.index,
				    rest = _objectWithoutProperties(override, ["index"]);

				var newRetracements = retracements.map(function (each, idx) {
					return idx === index ? _extends({}, rest, { selected: true }) : each;
				});
				this.setState({
					override: null,
					retracements: newRetracements
				}, function () {
					_this4.props.onComplete(newRetracements, moreProps);
				});
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _this5 = this;

			var _state3 = this.state,
			    current = _state3.current,
			    override = _state3.override,
			    retracements = _state3.retracements;
			var _props = this.props,
			    stroke = _props.stroke,
			    strokeWidth = _props.strokeWidth,
			    opacity = _props.opacity,
			    fontFamily = _props.fontFamily,
			    fontSize = _props.fontSize,
			    fontStroke = _props.fontStroke,
			    type = _props.type;
			var _props2 = this.props,
			    currentPositionStroke = _props2.currentPositionStroke,
			    currentPositionOpacity = _props2.currentPositionOpacity,
			    currentPositionStrokeWidth = _props2.currentPositionStrokeWidth,
			    currentPositionRadius = _props2.currentPositionRadius;
			var _props3 = this.props,
			    enabled = _props3.enabled,
			    hoverText = _props3.hoverText;

			var overrideIndex = (0, _utils.isDefined)(override) ? override.index : null;

			var currentRetracement = (0, _utils.isDefined)(current) && (0, _utils.isDefined)(current.x2) ? _react2.default.createElement(_EachFibRetracement2.default, _extends({
				interactive: false,
				type: type,
				stroke: stroke,
				strokeWidth: strokeWidth,
				opacity: opacity,
				fontFamily: fontFamily,
				fontSize: fontSize,
				fontStroke: fontStroke,
				hoverText: hoverText
			}, current)) : null;
			return _react2.default.createElement(
				"g",
				null,
				retracements.map(function (each, idx) {
					return _react2.default.createElement(_EachFibRetracement2.default, _extends({ key: idx,
						ref: _this5.saveNodeList,
						index: idx,
						type: type,
						selected: each.selected,
						stroke: stroke,
						strokeWidth: strokeWidth,
						opacity: opacity,
						fontFamily: fontFamily,
						fontSize: fontSize,
						fontStroke: fontStroke,
						hoverText: hoverText
					}, idx === overrideIndex ? override : each, {
						onDrag: _this5.handleDrag,
						onDragComplete: _this5.handleDragComplete
					}));
				}),
				currentRetracement,
				_react2.default.createElement(_MouseLocationIndicator2.default, {
					enabled: enabled,
					snap: false,
					r: currentPositionRadius,
					stroke: currentPositionStroke,
					opacity: currentPositionOpacity,
					strokeWidth: currentPositionStrokeWidth,
					onMouseDown: this.handleStart,
					onClick: this.handleEnd,
					onMouseMove: this.handleDrawRetracement
				}),
				_react2.default.createElement(_GenericChartComponent2.default, {

					svgDraw: _utils.noop,
					canvasToDraw: _GenericComponent.getMouseCanvas,
					canvasDraw: _utils.noop,

					onClick: this.handleClick,

					drawOn: ["mousemove", "pan", "drag"]
				})
			);
		}
	}]);

	return FibonacciRetracement;
}(_react.Component);

FibonacciRetracement.propTypes = {
	enabled: _propTypes2.default.bool.isRequired,
	fontFamily: _propTypes2.default.string.isRequired,
	fontSize: _propTypes2.default.number.isRequired,
	fontStroke: _propTypes2.default.string,
	chartCanvasType: _propTypes2.default.string,
	width: _propTypes2.default.number,
	strokeWidth: _propTypes2.default.number,
	stroke: _propTypes2.default.string,
	opacity: _propTypes2.default.number,

	onStart: _propTypes2.default.func,
	onComplete: _propTypes2.default.func,
	onSelect: _propTypes2.default.func,

	type: _propTypes2.default.oneOf(["EXTEND", // extends from -Infinity to +Infinity
	"BOUND"]).isRequired,
	hoverText: _propTypes2.default.object.isRequired,

	currentPositionStroke: _propTypes2.default.string,
	currentPositionStrokeWidth: _propTypes2.default.number,
	currentPositionOpacity: _propTypes2.default.number,
	currentPositionRadius: _propTypes2.default.number,

	childProps: _propTypes2.default.any,
	retracements: _propTypes2.default.array.isRequired
};

FibonacciRetracement.defaultProps = {
	enabled: true,
	stroke: "#000000",
	strokeWidth: 1,
	opacity: .9,
	fontFamily: "Helvetica Neue, Helvetica, Arial, sans-serif",
	fontSize: 10,
	fontStroke: "#000000",
	type: "EXTEND",
	retracements: [],

	onStart: _utils.noop,
	onComplete: _utils.noop,
	onSelect: _utils.noop,

	hoverText: _extends({}, _HoverTextNearMouse2.default.defaultProps, {
		enable: true,
		bgHeight: 18,
		bgWidth: 120,
		text: "Click to select object"
	}),
	currentPositionStroke: "#000000",
	currentPositionOpacity: 1,
	currentPositionStrokeWidth: 3,
	currentPositionRadius: 4

};

exports.default = FibonacciRetracement;